

#include <Be.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "gui.h"

char *version = "BeBochs Configurator 1.0";

/// Class Variables ///

  //StartWindow     *pwin;
  StartView       *sView;
  ROMView         *rView;
  HWRView         *hView;
  SYSView         *yView;


#define BeBC_OK 'bSTR'
#define BeBC_CANCEL 'bEND'


#define MOUSE_MODE 'mMOD'
#define DEFT_MSG 'defM'

entry_ref   *file_ref = NULL;
BFile		*aFile;
BFile		*stFile;

char 		*FLOPPY_A_FILE;  
char 		*FLOPPY_A_TYPE;
char 		*FLOPPY_A_STATUS;
char 		*FLOPPY_B_FILE;
char 		*FLOPPY_B_TYPE;
char 		*FLOPPY_B_STATUS;
char 		*HD_FILE;
char 		*HD_CYL;
char 		*HD_HEAD;
char 		*HD_SPT;
char		*CDR_FILE;
char		*CDR_STATUS;
char 		*BOOT_UNIT;
char		*MEGS_RAM;
char 		*BIOS_ROM_FILE;
char 		*BIOS_ROM_ADDR;
char 		*VGA_ROM;
char 		*LOG_FILE;
char 		*DELAY_IPS;
char 		*DELAY_VGA;
char 		*DELAY_KEY;
char 		*DELAY_FLP;


char bochsrc_path[512];

StartWindow::StartWindow(BRect frame):BWindow(frame, ".bochsrc editor", B_TITLED_WINDOW, B_NOT_RESIZABLE){

		fRef = NULL;
		
	FLOPPY_A_FILE = (char *)malloc(1); FLOPPY_A_FILE[0] = 0;
	FLOPPY_A_TYPE = (char *)malloc(1); FLOPPY_A_TYPE[0] = 0;
	FLOPPY_A_STATUS = (char *)malloc(1); FLOPPY_A_STATUS[0] = 0;
	
	FLOPPY_B_FILE = (char *)malloc(1); FLOPPY_B_FILE[0] = 0;
	FLOPPY_B_TYPE = (char *)malloc(1); FLOPPY_B_TYPE[0] = 0;
	FLOPPY_B_STATUS = (char *)malloc(1); FLOPPY_B_STATUS[0] = 0;
	
	parse_bochsrc();	
	
	BRect r;
	r = Bounds();
	sView = new StartView(r, "StartView", fRef);
	sView->SetViewColor(210,210,210);
	AddChild(sView);
}

bool StartWindow::QuitRequested() 
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return BWindow::QuitRequested();
}

void StartWindow::MessageReceived(BMessage *message){
	char			str[256];
	entry_ref		dir;
	BDirectory		directory;
	BEntry			entry;
	BFile			file;
	BNodeInfo		*node;
	
	switch(message->what) {

		case BeBC_OK:
			sView->Save();
			be_app->PostMessage(B_QUIT_REQUESTED);
			break;
		case BeBC_CANCEL:
			be_app->PostMessage(B_QUIT_REQUESTED);
			break;

		default:
			BWindow::MessageReceived(message);
	}
}


void StartWindow::parse_bochsrc(void)
{
  FILE *fd;
  char *ret;
  char line[512];

  char *ptr;

  ptr = getenv("HOME");
  if (!ptr) {
    fprintf(stderr, "could not get environment variable 'HOME'.\n");
    exit(1);
    }
    

  strcat(bochsrc_path, ".bochsrc");
  fd = fopen(bochsrc_path, "r");
  

	
  if (!fd) {
    fprintf(stderr, "could not open file '%s', trying home directory.\n",
      bochsrc_path);


    strcpy(bochsrc_path, ptr);
    strcat(bochsrc_path, "/");
    strcat(bochsrc_path, ".bochsrc");

    fd = fopen(bochsrc_path, "r");
    if (!fd) {
    
	  
      fprintf(stderr, "could not open file '%s'.\n", bochsrc_path);
      // no file used, nothing left to do.  This is now valid,
      // as you can pass everything on the command line.
      return;
      }
    else
      fprintf(stderr, "# using rc file '%s'.\n", bochsrc_path);
    }
  else
    fprintf(stderr, "# using rc file '%s'.\n", bochsrc_path);



  do {
    ret = fgets(line, sizeof(line)-1, fd);
    line[sizeof(line) - 1] = '\0';
    line[strlen(line) - 1] = '\0';
    if ((ret != NULL) && strlen(line)) {
      parse_line_unformatted(line);
      }
    } while (!feof(fd));
    
}

void StartWindow::parse_line_unformatted(char *line)
{
  char *ptr;
  unsigned i, string_i;
  char string[512];
  char *params[40];
  int num_params;
  bool inquotes = 0;

  if (line == NULL) return;

  // if passed nothing but whitespace, just return
  for (i=0; i<strlen(line); i++) {
    if (!isspace(line[i])) break;
    }
  if (i>=strlen(line))
    return;

  num_params = 0;

  ptr = strtok(line, ":");
  while (ptr) {
    string_i = 0;
    for (i=0; i<strlen(ptr); i++) {
      if (ptr[i] == '"')
        inquotes = !inquotes;
      else
        if (!isspace(ptr[i]) || inquotes) {
          string[string_i++] = ptr[i];
          }
      }
    string[string_i] = '\0';
    strcpy(ptr, string);
    params[num_params++] = ptr;
    ptr = strtok(NULL, ",");
    }
  parse_bxrsc(num_params, &params[0]);
  
}



void StartWindow::parse_bxrsc(int num_params, char *params[])
{
  int i;

  if (num_params < 1) return;

  if (params[0][0] == '#') return; /* comment */
  else if (!strcmp(params[0], "floppya")) {  // FLOPPY A

    for (i=1; i<num_params; i++) {
      if (!strncmp(params[i], "1_44=", 5)) {
      	FLOPPY_A_TYPE = (char *)malloc(strlen("3.5\" 1.44 MB")+1); strcpy(FLOPPY_A_TYPE, "3.5\" 1.44 MB");
      	FLOPPY_A_FILE = (char *)malloc(strlen(&params[i][5]) + 1); strcpy(FLOPPY_A_FILE, &params[i][5]);
        }
      else if (!strncmp(params[i], "1_2=", 4)) {
      	FLOPPY_A_TYPE = (char *)malloc(strlen("5.25\" 1.2 MB")+1); strcpy(FLOPPY_A_TYPE, "5.25\" 1.2 MB");
      	FLOPPY_A_FILE = (char *)malloc(strlen(&params[i][4]) + 1); strcpy(FLOPPY_A_FILE, &params[i][4]);
        }
      else if (!strncmp(params[i], "720k=", 5)) {
      	FLOPPY_A_TYPE = (char *)malloc(strlen("3.5\" 720 KB")+1); strcpy(FLOPPY_A_TYPE, "3.5\" 720 KB");
      	FLOPPY_A_FILE = (char *)malloc(strlen(&params[i][5]) + 1); strcpy(FLOPPY_A_FILE, &params[i][5]);
        }
      else if (!strncmp(params[i], "status=ejected", 14)){
      	FLOPPY_A_STATUS = (char *)malloc(strlen("ejected")+1); 
      	strcpy(FLOPPY_A_STATUS, "ejected");
      	}
      else if (!strncmp(params[i], "status=inserted", 15)){
      	FLOPPY_A_STATUS = (char *)malloc(strlen("inserted")+1); 
      	strcpy(FLOPPY_A_STATUS, "inserted");
      	}
      else {
        fprintf(stderr, ".bochsrc: floppya attribute '%s' not understood.\n", params[i]);
        //exit(1);
        }
      } 
    }

  else if (!strcmp(params[0], "floppyb")) {  // FLOPPY B
    for (i=1; i<num_params; i++) {
      if (!strncmp(params[i], "1_44=", 5)) {
      	FLOPPY_B_TYPE = (char *)malloc(strlen("3.5\" 1.44 MB")+1); strcpy(FLOPPY_B_TYPE, "3.5\" 1.44 MB");
      	FLOPPY_B_FILE = (char *)malloc(strlen(&params[i][5]) + 1); strcpy(FLOPPY_B_FILE, &params[i][5]);
        }
      else if (!strncmp(params[i], "1_2=", 4)) {
      	FLOPPY_B_TYPE = (char *)malloc(strlen("5.25\" 1.2 MB")+1); strcpy(FLOPPY_B_TYPE, "5.25\" 1.2 MB");
      	FLOPPY_B_FILE = (char *)malloc(strlen(&params[i][4]) + 1); strcpy(FLOPPY_B_FILE, &params[i][4]);
        }
      else if (!strncmp(params[i], "720k=", 5)) {
      	FLOPPY_B_TYPE = (char *)malloc(strlen("3.5\" 720 KB")+1); strcpy(FLOPPY_B_TYPE, "3.5\" 720 KB");
      	FLOPPY_B_FILE = (char *)malloc(strlen(&params[i][5]) + 1); strcpy(FLOPPY_B_FILE, &params[i][5]);
        }
      else if (!strncmp(params[i], "status=ejected", 14)){
      	FLOPPY_B_STATUS = (char *)malloc(strlen("ejected")+1); 
      	strcpy(FLOPPY_B_STATUS, "ejected");
      	}
      else if (!strncmp(params[i], "status=inserted", 15)){
      	FLOPPY_B_STATUS = (char *)malloc(strlen("inserted")+1); 
      	strcpy(FLOPPY_B_STATUS, "inserted");
      	}
      else {
        fprintf(stderr, ".bochsrc: floppya attribute '%s' not understood.\n", params[i]);
        //exit(1);
        }
    }
  }

  else if (!strcmp(params[0], "diskc")) {
    if (num_params != 5) {
      fprintf(stderr, ".bochsrc: diskc directive malformed.\n");
      //exit(1);
      }
    if (strncmp(params[1], "file=", 5) ||
        strncmp(params[2], "cyl=", 4) ||
        strncmp(params[3], "heads=", 6) ||
        strncmp(params[4], "spt=", 4)) {
      fprintf(stderr, ".bochsrc: diskc directive malformed.\n");
      //exit(1);
      }
    
    
    HD_FILE = (char *)malloc(strlen(&params[1][5]) + 1); strcpy(HD_FILE, &params[1][5]);
	HD_CYL = (char *)malloc(strlen(&params[2][4]) + 1); strcpy(HD_CYL, &params[2][4]);
	HD_HEAD = (char *)malloc(strlen(&params[3][6]) + 1); strcpy(HD_HEAD, &params[3][6]);
	HD_SPT = (char *)malloc(strlen(&params[4][4]) + 1); strcpy(HD_SPT, &params[4][4]);


    }


  else if (!strcmp(params[0], "diskd")) {
  return;
  }


  else if (!strcmp(params[0], "boot")) {
    if (!strcmp(params[1], "a") ||
        !strcmp(params[1], "c")) {
      BOOT_UNIT = (char *)malloc(strlen(params[1]) + 1);
      strcpy(BOOT_UNIT, params[1]);

    }
    else {
      fprintf(stderr, ".bochsrc: boot directive with unknown boot device '%s'.\n",
        params[1]);
      fprintf(stderr, "          use 'a', or 'c'.\n");
      //exit(1);
    }
  }

  else if (!strcmp(params[0], "cdromd")) {
    if (num_params != 3) {
      fprintf(stderr, ".bochsrc: cdromd directive malformed.\n");
      }
    if (strncmp(params[1], "dev=", 4) || strncmp(params[2], "status=", 7)) {
      fprintf(stderr, ".bochsrc: cdromd directive malformed.\n");
      }
    //strcpy(bx_options.cdromd.dev, &params[1][4]);
	CDR_FILE = (char *)malloc(strlen(&params[1][4]) + 1);
	strcpy(CDR_FILE, &params[1][4]);
	
    if (!strcmp(params[2], "status=inserted")){
      	CDR_STATUS = (char *)malloc(strlen("inserted")+1); 
      	strcpy(CDR_STATUS, "inserted");
    }else if (!strcmp(params[2], "status=ejected")){
      	CDR_STATUS = (char *)malloc(strlen("ejected")+1); 
      	strcpy(CDR_STATUS, "ejected");
    }else {
      fprintf(stderr, ".bochsrc: cdromd directive malformed.\n");
      }

    }

  else if (!strcmp(params[0], "log")) {
    if (num_params != 2) {
      fprintf(stderr, ".bochsrc: log directive has wrong # args.\n");
      //exit(1);
      }
	LOG_FILE = (char *)malloc(strlen(params[1]) + 1);
	strcpy(LOG_FILE, params[1]);
    }
    
  else if (!strcmp(params[0], "romimage")) {
    if (num_params != 3) {
      fprintf(stderr, ".bochsrc: romimage directive: wrong # args.\n");
      //exit(1);
      }
    if (strncmp(params[1], "file=", 5)) {
      fprintf(stderr, ".bochsrc: romimage directive malformed.\n");
      //exit(1);
      }
    if (strncmp(params[2], "address=", 8)) {
      fprintf(stderr, ".bochsrc: romimage directive malformed.\n");
      //exit(1);
      }
    BIOS_ROM_FILE = (char *)malloc(strlen(&params[1][5]) + 1);
    strcpy(BIOS_ROM_FILE, &params[1][5]);
    BIOS_ROM_ADDR = (char *)malloc(strlen(&params[2][8]) + 1);
    strcpy(BIOS_ROM_ADDR, &params[2][8]);

    }

  else if (!strcmp(params[0], "vgaromimage")) {
    if (num_params != 2) {
      fprintf(stderr, ".bochsrc: vgaromimage directive: wrong # args.\n");
      //exit(1);
      }
    VGA_ROM = (char *)malloc(strlen(params[1]) + 1);
    strcpy(VGA_ROM, params[1]);
    }

  else if (!strcmp(params[0], "vga_update_interval")) {
    if (num_params != 2) {
      fprintf(stderr, ".bochsrc: vga_update_interval directive: wrong # args.\n");
      //exit(1);
    }
    DELAY_VGA = (char *)malloc(strlen(params[1]) + 1);
    strcpy(DELAY_VGA, params[1]);
    }

  else if (!strcmp(params[0], "keyboard_serial_delay")) {
    if (num_params != 2) {
      fprintf(stderr, ".bochsrc: keyboard_serial_delay directive: wrong # args.\n");
      //exit(1);
      }
    DELAY_KEY = (char *)malloc(strlen(params[1]) + 1);
	strcpy(DELAY_KEY, params[1]);
    //yView->fSYSkey->SetText(val);
    
    }

  else if (!strcmp(params[0], "megs")) {
    if (num_params != 2) {
      fprintf(stderr, ".bochsrc: megs directive: wrong # args.\n");
      //exit(1);
      }
    //

    //MEGS_RAM = params[1];
	MEGS_RAM = (char *)malloc(strlen(params[1]) + 1);
	strcpy(MEGS_RAM, params[1]);


    }
   
  else if (!strcmp(params[0], "floppy_command_delay")) {
    if (num_params != 2) {
      fprintf(stderr, ".bochsrc: floppy_command_delay directive: wrong # args.\n");
      //exit(1);
      }
      
    DELAY_FLP = (char *)malloc(strlen(params[1]) + 1);
    strcpy(DELAY_FLP, params[1]);

    }
	
  else if (!strcmp(params[0], "ips")) {
    if (num_params != 2) {
      fprintf(stderr, ".bochsrc: ips directive: wrong # args.\n");
      //exit(1);
      }
    DELAY_IPS = (char *)malloc(strlen(params[1]) + 1);
    strcpy(DELAY_IPS, params[1]);

    }

  else if (!strcmp(params[0], "mouse")) {
  }
  else if (!strcmp(params[0], "private_colormap")) {
  }

  else if (!strcmp(params[0], "i440fxsupport")) {
  }
}





StartView::StartView(BRect frame, char *name, entry_ref *ref):BView(frame, name, B_FOLLOW_NONE, B_WILL_DRAW){

	BRect r;
	BPoint p;
	
	BTabView *tabView;
	BTab	*tab;
	
	float bLen;
	float bHei;
	bLen = 50;
	bHei = 30;
	
	SetViewColor(210,210,210);
	
	// Buttons
	r = Bounds();
	r.InsetBy(10,10);
	
	r.top = r.bottom - bHei;
	r.right = r.left + bLen;
	
	bStart = new BButton(r,"START","OK", new BMessage(BeBC_OK), B_FOLLOW_LEFT, B_WILL_DRAW);
	AddChild(bStart);	r.OffsetBy(bLen + 10, 0);	
	bStart->MakeDefault(true);
	
	bEnd = new BButton(r,"END","Cancel", new BMessage(BeBC_CANCEL), B_FOLLOW_LEFT, B_WILL_DRAW);
	AddChild(bEnd);	r.OffsetBy(bLen + 10, 0);	

	
	
	//Views
	r = Bounds();	p = BPoint(0,0);
	
  	p.y = r.Height();  	p.y -= bHei + 20;
  	
  	r.SetLeftBottom(p);	r.InsetBy(5,5);
	
	tabView = new BTabView(r, "tab_view"); 
	//tabView->SetViewColor(247,194,132,255);
	
	r = tabView->Bounds(); 
	r.bottom -= tabView->TabHeight() + 5;
	r.right -= 4;
	r.InsetBy(10,10);
	
	
	
	tab = new BTab();
	tabView->AddTab(hView = new HWRView(r), tab); 
	tab->SetLabel("Hardware Settings");

	tab = new BTab();
	tabView->AddTab(yView = new SYSView(r), tab); 
	tab->SetLabel("System Settings");	
		
	tab = new BTab();
	tabView->AddTab(rView = new ROMView(r), tab); 
	tab->SetLabel("Advanced Settings");	
	
	AddChild(tabView);

}


void StartView::MessageReceived(BMessage *message){

}

//--------------------------------------------------------------------

void StartView::NewFile(entry_ref *ref)
{
	if (aFile)
		delete aFile;
	aFile = new BFile(ref, O_RDWR);
	Save();
}

//--------------------------------------------------------------------

void StartView::Save(void)
{

	FILE *fdout;
	
	fdout = fopen("/boot/home/.bochsrc", "w");
	for (int i=0; i<5; i++) fprintf(fdout,"######"); fprintf(fdout,"\n");
	fprintf(fdout, "#%s\n\n", version);
	for (int i=0; i<5; i++) fprintf(fdout,"######"); fprintf(fdout,"\n");
	
	BMenu *menu; 
	BMenuItem *item;
	BTextView *textview;
	BString string;
	const char *label;
	Window()->Lock();
	
	const char *insert = "inserted";
	
	char *var1, *var2, *var3, *var4;
	
	//BOOT
    menu = hView->mfHWRboot->Menu();
    item = menu->FindMarked();
    label = item->Label();	
	
    if (!strcmp(label, "A: Floppy Drive")){
    	var1 = "a";
    }
    if (!strcmp(label, "C: Hard Drive")){
    	var1 =  "c";
    }
    for (int i=0; i<5; i++) fprintf(fdout,"######"); fprintf(fdout,"\n");
	fprintf(fdout, "#BOOT UNIT\nboot: %s\n\n", var1);

	//MEGS
	var1 = (char *)hView->fHWRmegs->Text();
	for (int i=0; i<5; i++) fprintf(fdout,"######"); fprintf(fdout,"\n");
	fprintf(fdout, "#RAM TO EMULATE\nmegs: %s\n\n", var1);
	for (int i=0; i<5; i++) fprintf(fdout,"######"); fprintf(fdout,"\n");
	fprintf(fdout, "#DRIVES\n");
	// Floppy A
	textview = hView->fHWRafile->TextView();

	if (textview->TextLength()>1){
		menu = hView->mfHWRatype->Menu();
    	item = menu->FindMarked();
    	label = item->Label();
    	var2 = (char *)hView->fHWRafile->Text();
    	
	    if (!strcmp(label, "3.5\" 1.44 MB")) var1 = "1_44";
	    if (!strcmp(label, "5.25\" 1.2 MB")) var1 = "1_2";
	    if (!strcmp(label, "3.5\" 720 KB")) var1 = "720k";
	    
	    if (hView->cHWRaenab->Value() == B_CONTROL_ON) {
	    	var3 = "inserted";
	    }else{
	        var3 = "ejected";
	    }
	    
		fprintf(fdout, "floppya: %s=%s, status=%s\n", var1, var2, var3);
	}

	// Floppy B

	textview = hView->fHWRbfile->TextView();

	if (textview->TextLength()>1){
		menu = hView->mfHWRbtype->Menu();
    	item = menu->FindMarked();
    	label = item->Label();
    	var2 = (char *)hView->fHWRbfile->Text();
    	
	    if (!strcmp(label, "3.5\" 1.44 MB")) var1 = "1_44";
	    if (!strcmp(label, "5.25\" 1.2 MB")) var1 = "1_2";
	    if (!strcmp(label, "3.5\" 720 KB")) var1 = "720k";
	    
	    if (hView->cHWRbenab->Value() == B_CONTROL_ON) {
	    	var3 = "inserted";
	    }else{
	        var3 = "ejected";
	    }
	    
		fprintf(fdout, "floppyb: %s=%s, status=%s\n", var1, var2, var3);
    }	



	// HD C
    menu = hView->mfHWRcsize->Menu();
    item = menu->FindMarked();
    label = item->Label();
	var1 = (char *) hView->fHWRcfile->Text();
	
	if (!strcmp(label, " 10 MB")){
	    var2 = "306";    	var3 = "4";	    	var4 = "17";
    }else if (!strcmp(label, " 20 MB")){
	    var2 = "615";    	var3 = "4";	    	var4 = "17";
    }else if (!strcmp(label, " 30 MB")){
	    var2 = "615";    	var3 = "6";	    	var4 = "17";
    }else if (!strcmp(label, " 46 MB")){
    	var2 = "940";    	var3 = "6";	    	var4 = "17";
    }else if (!strcmp(label, " 62 MB")){
	    var2 = "940";    	var3 = "8";    		var4 = "17";
    }else if (!strcmp(label, "112 MB")){
	    var2 = "900";    	var3 = "15";    	var4 = "17";
    }else if (!strcmp(label, "126 MB")){
	    var2 = "256";    	var3 = "16";    	var4 = "63";
    }else  if (!strcmp(label, "483 MB")){
	    var2 = "1024";    	var3 = "15";    	var4 = "63";
	}else if (!strcmp(label, "504 MB")){
	    var2 = "1024";    	var3 = "16";    	var4 = "63";
    }
    
    fprintf(fdout, "diskc: file=\"%s\", cyl=%s, heads=%s, spt=%s\n", var1, var2, var3, var4);

    //CD-ROM
	var1 = (char *) hView->fHWRcdrom->Text();
	fprintf(fdout, "cdromd: dev=%s, status=inserted\n", var1);
	
	fprintf(fdout, "\n");
    //LOG
	var1 = (char *) yView->fSYSlog->Text();
	fprintf(fdout, "log: %s\n", var1);

	//KEY UPDATE
	var1 = (char *) yView->fSYSkey->Text();
	fprintf(fdout, "keyboard_serial_delay: %s\n", var1);
	
	//FLOPPY DELAY
	var1 = (char *) yView->fSYSfcd->Text();	
	fprintf(fdout, "floppy_command_delay: %s\n", var1);
	
	//VGA UPDATE
	var1 = (char *) yView->fSYSvga->Text();
	fprintf(fdout, "vga_update_interval: %s\n", var1);
	
	//IPS
	var1 = (char *) yView->fSYSips->Text();
	fprintf(fdout, "ips: %s\n", var1);
	
	//ROM BIOS
	var1 = (char *) rView->fROMbios->Text();
	var2 = (char *) rView->fROMaddr->Text();
	fprintf(fdout, "romimage: file=%s, address=%s\n", var1, var2);
    
	//VGA BIOS
	var1 = (char *) rView->fROMvga->Text();
	fprintf(fdout, "vgaromimage: %s\n", var1);

	Window()->Unlock();
	
	fprintf(fdout, "mouse: enabled=1\n");
	fprintf(fdout, "private_colormap: enabled=0\n");
	fprintf(fdout, "i440fxsupport: enabled=0\n");
	fprintf(fdout, "newharddrivesupport: enabled=1\n");
	fclose(fdout);
}

//--------------------------------------------------------------------

ROMView::ROMView(BRect frame):BView(frame, "ROMView", B_FOLLOW_NONE, B_WILL_DRAW)
{
  	alignment forLabel;
  	alignment forText;
  	float tcDivider;
  	
  	BRect	r;
	float hInc;
//  	BRect   r1;
  	
  	r = Bounds();
  	r.InsetBy(20,20);
  	r.bottom = r.top + 20;
  	hInc = 25;
  	
  	SetViewColor(107,203,205,0);
  	forLabel = B_ALIGN_LEFT;
  	forText = B_ALIGN_LEFT;
  	
  	tcDivider = 125;
  	
  	fROMvga = new BTextControl(r,"fROMvga","VGA ROM path", VGA_ROM, new BMessage(DEFT_MSG));
	AddChild(fROMvga);
	fROMvga->SetDivider(tcDivider); fROMvga->SetAlignment(forLabel,forText);
	r.OffsetBy(0,hInc+10);
	
	fROMbios = new BTextControl(r,"fROMbios","BIOS ROM path",BIOS_ROM_FILE, new BMessage(DEFT_MSG));
	AddChild(fROMbios);
	fROMbios->SetDivider(tcDivider); fROMbios->SetAlignment(forLabel,forText);
	r.OffsetBy(0,hInc);
	
	fROMaddr = new BTextControl(r,"fROMaddr","BIOS ROM addr",BIOS_ROM_ADDR, new BMessage(DEFT_MSG));
	AddChild(fROMaddr);
	fROMaddr->SetDivider(tcDivider); fROMaddr->SetAlignment(forLabel,forText);
	r.OffsetBy(0,hInc);
	
}


HWRView::HWRView(BRect frame):BView(frame, "HWRView", B_FOLLOW_NONE, B_WILL_DRAW){
  	BRect		r;
	float 		hInc;
	float 		hIncSep;
  	BRect   	r1;
  	char		*text;
//  	attr_info	info;
  	alignment 	forLabel;
  	alignment 	forText;
  	float 		tcDivider;
  	BMenuItem 	*item;
//	BPoint 		line_start, line_end;
	BMenu		*menu;
	int32 file_size;

  	
  	forLabel = B_ALIGN_LEFT;
  	forText = B_ALIGN_LEFT;
  	tcDivider = 125;
  	
	SetViewColor(107,203,205,0);
	
  	r = Bounds();
  	r.InsetBy(20,20);
  	r.bottom = r.top + 20;
  	hInc = 20;
  	hIncSep = 15;
  	r1 = r;		r1.right = 175;

	// RAM
	fHWRmegs = new BTextControl(r1,"fHWRmegs","RAM (MB) emulated", MEGS_RAM, new BMessage(DEFT_MSG));
	AddChild(fHWRmegs);		fHWRmegs->SetDivider(tcDivider);	fHWRmegs->SetAlignment(forLabel,forText);
	r.OffsetBy(0,hInc+hIncSep);
	
	//Floppy A
		//File/Dev Path

	
	fHWRafile = new BTextControl(r,"fHWRffile","Drive A dev/image path", FLOPPY_A_FILE, new BMessage(DEFT_MSG));
	AddChild(fHWRafile);	fHWRafile->SetDivider(tcDivider);	fHWRafile->SetAlignment(forLabel,forText);
	r.OffsetBy(0,hInc);
		//Drive Type

	mfHWRatype = new BMenuField(r,"mfHWRastat","Drive A Type", mHWRatype = new BMenu("Type",B_ITEMS_IN_COLUMN), 
	B_FOLLOW_LEFT, B_WILL_DRAW);	mfHWRatype->SetDivider(tcDivider);	mfHWRatype->SetAlignment(forLabel);
	
	item = new BMenuItem("3.5\" 1.44 MB",new BMessage(DEFT_MSG),0,0);	mHWRatype->AddItem(item);
	item = new BMenuItem("5.25\" 1.2 MB",new BMessage(DEFT_MSG),0,0);	mHWRatype->AddItem(item);
	item = new BMenuItem("3.5\" 720 KB",new BMessage(DEFT_MSG),0,0);	mHWRatype->AddItem(item);
	
	AddChild(mfHWRatype);
	
	menu = mfHWRatype->Menu();
	menu->SetLabelFromMarked(true);
	
	if (!strcmp(FLOPPY_A_TYPE, "3.5\" 1.44 MB")){ item = menu->FindItem("3.5\" 1.44 MB"); item->SetMarked(true);	}
	if (!strcmp(FLOPPY_A_TYPE, "5.25\" 1.2 MB")){ item = menu->FindItem("5.25\" 1.2 MB"); item->SetMarked(true);	}
	if (!strcmp(FLOPPY_A_TYPE, "3.5\" 720 KB")) { item = menu->FindItem("3.5\" 720 KB");  item->SetMarked(true);	}
	
	r1 = r; r1.left = 250;
	
		//Status
	cHWRaenab = new BCheckBox(r1, "cHWRaenab", "Inserted", new BMessage(DEFT_MSG), B_FOLLOW_LEFT, B_WILL_DRAW);
	AddChild(cHWRaenab);
	if (!strcmp(FLOPPY_A_STATUS, "inserted")) cHWRaenab->SetValue(B_CONTROL_ON);
	r.OffsetBy(0,hInc+hIncSep);
	
	//Floppy B
		//File/Dev Path

	fHWRbfile = new BTextControl(r,"fHWRbfile","Drive B dev/image path", FLOPPY_B_FILE, new BMessage(DEFT_MSG));
	AddChild(fHWRbfile);	fHWRbfile->SetDivider(tcDivider);	fHWRbfile->SetAlignment(forLabel,forText);
	r.OffsetBy(0,hInc);
		//Drive Type

	mfHWRbtype = new BMenuField(r,"mfHWRbstat","Drive B Type", mHWRbtype = new BMenu("Type",B_ITEMS_IN_COLUMN), 
	B_FOLLOW_LEFT, B_WILL_DRAW);	mfHWRbtype->SetDivider(tcDivider);	mfHWRbtype->SetAlignment(forLabel);

	
	item = new BMenuItem("3.5\" 1.44 MB",new BMessage(DEFT_MSG),0,0);	mHWRbtype->AddItem(item);
	item = new BMenuItem("5.25\" 1.2 MB",new BMessage(DEFT_MSG),0,0);	mHWRbtype->AddItem(item);
	item = new BMenuItem("3.5\" 720 KB",new BMessage(DEFT_MSG),0,0);	mHWRbtype->AddItem(item);

	AddChild(mfHWRbtype);
	menu = mfHWRbtype->Menu();
	menu->SetLabelFromMarked(true);
	if (!strcmp(FLOPPY_B_TYPE, "3.5\" 1.44 MB")){ item = menu->FindItem("3.5\" 1.44 MB"); item->SetMarked(true);	}
	if (!strcmp(FLOPPY_B_TYPE, "5.25\" 1.2 MB")){ item = menu->FindItem("5.25\" 1.2 MB"); item->SetMarked(true);	}
	if (!strcmp(FLOPPY_B_TYPE, "3.5\" 720 KB")) { item = menu->FindItem("3.5\" 720 KB");  item->SetMarked(true);	}	
	r1 = r; r1.left = 250;
		//Status

	cHWRbenab = new BCheckBox(r1, "cHWRbenab", "Inserted", new BMessage(DEFT_MSG), B_FOLLOW_LEFT, B_WILL_DRAW);
	AddChild(cHWRbenab);
	if (!strcmp(FLOPPY_B_STATUS, "inserted")) cHWRbenab->SetValue(B_CONTROL_ON);
	r.OffsetBy(0,hInc+hIncSep);
	
	// HD

	fHWRcfile = new BTextControl(r,"fHWRcfile","Drive C file path", HD_FILE, new BMessage(DEFT_MSG));
	AddChild(fHWRcfile);	fHWRcfile->SetDivider(tcDivider);	fHWRcfile->SetAlignment(forLabel,forText);	
	r.OffsetBy(0,hInc); 	r1 = r;		r1.right = 200;
	
	mfHWRcsize = new BMenuField(r,"mfHWRcsize","Drive C size", mHWRcsize = new BMenu("Size",B_ITEMS_IN_COLUMN), 
	B_FOLLOW_LEFT, B_WILL_DRAW);	mfHWRcsize->SetDivider(tcDivider);	mfHWRcsize->SetAlignment(forLabel);
	//(new BAlert("","Debug","OK"))->Go();
	file_size = atoi(HD_CYL);//(new BAlert("","Debug CYL","OK"))->Go();
	file_size *= atoi(HD_HEAD);//(new BAlert("","Debug HEAD","OK"))->Go();
	file_size *= atoi(HD_SPT);//(new BAlert("","Debug SPT","OK"))->Go();
		
	item = new BMenuItem(" 10 MB",new BMessage(DEFT_MSG),0,0);	mHWRcsize->AddItem(item);
	item = new BMenuItem(" 20 MB",new BMessage(DEFT_MSG),0,0);	mHWRcsize->AddItem(item);
	item = new BMenuItem(" 30 MB",new BMessage(DEFT_MSG),0,0);	mHWRcsize->AddItem(item);
	item = new BMenuItem(" 46 MB",new BMessage(DEFT_MSG),0,0);	mHWRcsize->AddItem(item);
	item = new BMenuItem(" 62 MB",new BMessage(DEFT_MSG),0,0);	mHWRcsize->AddItem(item);
	item = new BMenuItem("112 MB",new BMessage(DEFT_MSG),0,0);	mHWRcsize->AddItem(item);
	item = new BMenuItem("126 MB",new BMessage(DEFT_MSG),0,0);	mHWRcsize->AddItem(item);
	item = new BMenuItem("483 MB",new BMessage(DEFT_MSG),0,0);	mHWRcsize->AddItem(item);
	item = new BMenuItem("504 MB",new BMessage(DEFT_MSG),0,0);	mHWRcsize->AddItem(item);
	AddChild(mfHWRcsize);
	r.OffsetBy(0,hInc+hIncSep);
    menu = mfHWRcsize->Menu();
    switch (file_size)
    {
    case 20808 : 	item = menu->FindItem(" 10 MB"); 	break;
    case 41820 : 	item = menu->FindItem(" 20 MB"); 	break; 
	case 62730 : 	item = menu->FindItem(" 30 MB"); 	break;
    case 95880 : 	item = menu->FindItem(" 46 MB");   	break;
    case 127840 :	item = menu->FindItem(" 62 MB");   	break;
    case 229500 :	item = menu->FindItem("112 MB");   	break;
    case 258048 :	item = menu->FindItem("126 MB");   	break;  	 
    case 967680 :	item = menu->FindItem("483 MB");   	break;
    case 1032192 :	item = menu->FindItem("504 MB");   	break;
    default:
    	item = new BMenuItem("Other", new BMessage(DEFT_MSG), 0, 0);
		menu->AddItem(item);
		break;
    }
    menu->SetLabelFromMarked(true);
	item->SetMarked(true);
	
	//CD-ROM
	fHWRcdrom = new BTextControl(r,"fHWRcdrom","CD-ROM DEV path", CDR_FILE, new BMessage(DEFT_MSG));
	AddChild(fHWRcdrom);	fHWRcdrom->SetDivider(tcDivider);	fHWRcdrom->SetAlignment(forLabel,forText);
	r.OffsetBy(0,hInc);
	//fHWRcdrom->SetEnabled(false);
	r1 = r; r1.left = 250;
		//Status
	cHWRcdenab = new BCheckBox(r1, "cHWRcdenab", "Inserted", new BMessage(DEFT_MSG), B_FOLLOW_LEFT, B_WILL_DRAW);
	AddChild(cHWRcdenab);
	if (!strcmp(CDR_STATUS, "inserted")) cHWRcdenab->SetValue(B_CONTROL_ON);

	r.OffsetBy(0,hInc); 	r1 = r;		r1.right = 200;

	//Boot
	mfHWRboot = new BMenuField(r,"mfHWRfstat","Boot Unit", mHWRboot = new BMenu("Unit",B_ITEMS_IN_COLUMN), 
	B_FOLLOW_LEFT, B_WILL_DRAW);	mfHWRboot->SetDivider(tcDivider);	mfHWRboot->SetAlignment(forLabel);
	menu = mfHWRboot->Menu(); 
	menu->SetLabelFromMarked(true);
	item = new BMenuItem("A: Floppy Drive",new BMessage(DEFT_MSG),0,0);	mHWRboot->AddItem(item);
	if (!strcmp(BOOT_UNIT, "a")) item->SetMarked(true);
	item = new BMenuItem("C: Hard Drive",new BMessage(DEFT_MSG),0,0);	mHWRboot->AddItem(item);
	if (!strcmp(BOOT_UNIT, "c")) item->SetMarked(true);
	
	AddChild(mfHWRboot);
	r.OffsetBy(0,hInc+hIncSep);


}




SYSView::SYSView(BRect frame):BView(frame,"SYSView", B_FOLLOW_NONE, B_WILL_DRAW){
/*

  BTextControl		*fSYSboot;
  BTextControl		*fSYSlog;
  BTextControl		*fSYSips;
  */
  	alignment forLabel;
  	alignment forText;
  	float tcDivider;
  	BRect	r;
	float hInc;
	float hIncSep;
	
	r = Bounds();
  	r.InsetBy(20,20);
  	r.bottom = r.top + 20;
  	hInc = 25;
  	hIncSep = 15;
  	
  	forLabel = B_ALIGN_LEFT;
  	forText = B_ALIGN_LEFT;
  	
  	tcDivider = 125;
  	
	SetViewColor(107,203,205,0);
	
	
	fSYSlog = new BTextControl(r,"fSYSlog","Log file path", LOG_FILE, new BMessage(DEFT_MSG));
	AddChild(fSYSlog); fSYSlog->SetDivider(tcDivider); fSYSlog->SetAlignment(forLabel,forText);	
	r.right = 200; r.OffsetBy(0,hInc); 
	
	fSYSips = new BTextControl(r,"fSYSips","IPS",DELAY_IPS, new BMessage(DEFT_MSG));
	AddChild(fSYSips); fSYSips->SetDivider(tcDivider); fSYSips->SetAlignment(forLabel,forText);
	r.OffsetBy(0,hInc);

	fSYSvga = new BTextControl(r,"fSYSvga","VGA Update Interval",DELAY_VGA, new BMessage(DEFT_MSG));
	AddChild(fSYSvga); fSYSvga->SetDivider(tcDivider); fSYSvga->SetAlignment(forLabel,forText);
	r.OffsetBy(0,hInc); 
	
	fSYSkey = new BTextControl(r,"fSYSkey","Keyboard Serial Delay",DELAY_KEY, new BMessage(DEFT_MSG));
	AddChild(fSYSkey); fSYSkey->SetDivider(tcDivider); fSYSkey->SetAlignment(forLabel,forText);
	r.OffsetBy(0,hInc); 

	fSYSfcd = new BTextControl(r,"fSYSfcd","Floppy Delay",DELAY_FLP, new BMessage(DEFT_MSG));
	AddChild(fSYSfcd); fSYSfcd->SetDivider(tcDivider); fSYSfcd->SetAlignment(forLabel,forText);
	r.OffsetBy(0,hInc); 

}



